
// ----------------------
#include "stdafx.h"
#include <Windows.h>
#include <AxSharedMem.h>

namespace AxWinLib {

CAxSharedMem::CAxSharedMem() :
	m_hMapObject (0),
	m_pMemory    (0),
	m_bExists    (false)
	
{
}

CAxSharedMem::~CAxSharedMem()
{
	Free();
}

bool CAxSharedMem::Create(LPCTSTR szName, DWORD dwSize)
{

	if (
		szName  != 0 ||
		*szName != 0 || 
		dwSize  != 0 ||
		m_hMapObject != 0
		)
	{
		m_hMapObject = ::CreateFileMapping
			(
			(HANDLE) 0xFFFFFFFF,
			NULL,
			PAGE_READWRITE,
			0,
			dwSize + sizeof(dwSize),
			szName
			);

		if (m_hMapObject == NULL)
			return false;

		m_bExists = (GetLastError() == ERROR_ALREADY_EXISTS);
		m_pMemory = ::MapViewOfFile(
			m_hMapObject,
			FILE_MAP_WRITE,
			0,
			0,
			0
			);

		if (m_pMemory == NULL)
		{
			Free();
			return false;
		}

		if (!m_bExists)
		{
			::memset(m_pMemory, 0 ,dwSize);
			::memcpy(m_pMemory, &dwSize, sizeof(dwSize));
		}
		return true;
	}

	return false;
}

bool CAxSharedMem::Free()
{
	if (m_pMemory)
		::UnmapViewOfFile(m_pMemory);

	if (m_hMapObject)
		::CloseHandle(m_hMapObject);

	m_hMapObject = 0;
	m_pMemory    = 0;
	m_bExists    = false;

	return true;
}

PVOID CAxSharedMem::GetPointer() const
{
	if (m_pMemory)
		return ((DWORD*)m_pMemory + 1);
	else
		return 0;
}

DWORD CAxSharedMem::GetSize() const
{
	if (m_pMemory)
	{
		DWORD dwSize = 0;
		::memcpy(&dwSize, m_pMemory, sizeof(dwSize));
		return dwSize;
	}
	else
		return 0;
}

}